--Creates all tables. 
--Previously dropping tables is convenient in developing.

DROP TABLE IF EXISTS Users;
CREATE TABLE "Users" ("_id" NUMERIC PRIMARY KEY ,	"clean" BOOLEAN NOT NULL  DEFAULT (0) ,	"deleted" BOOLEAN NOT NULL  DEFAULT (0) ,	"email" TEXT NOT NULL ,	"mobileNumber" TEXT,	"androidModel" TEXT NOT NULL ,	"imei" VARCHAR(15) NOT NULL ,	"published" INTEGER,	"updated" INTEGER,	"version" INTEGER NOT NULL);

DROP TABLE IF EXISTS Image;
CREATE TABLE Image (	"id" INTEGER PRIMARY KEY,	"blob" BLOB,	"contentType" TEXT,	"clean" INTEGER);

DROP TABLE IF EXISTS SiineText;
DROP TABLE IF EXISTS Siine;
CREATE  TABLE  Siine (	"id" INTEGER PRIMARY KEY  NOT NULL , 	"tag" TEXT,	"category" TEXT, 	"copyCounter" INTEGER, 	"domain" TEXT, 	"editable" INTEGER, 	"image" INTEGER, 	"kind" TEXT, 	"name" TEXT, 	"published" INTEGER, 	"type" TEXT,	"updated" INTEGER, 	"version" INTEGER,	"clean" INTEGER,	CONSTRAINT fk_siine_image FOREIGN KEY(image) REFERENCES Image(id));
CREATE TABLE SiineText(	siine INTEGER NOT NULL,	"text" TEXT,	"position" INTEGER,	"useCounter" INTEGER,	CONSTRAINT fk_siinetext_siine FOREIGN KEY(siine) REFERENCES Siine(id) ON DELETE CASCADE);

DROP TABLE IF EXISTS TrackSiine;
DROP TABLE IF EXISTS Track;
CREATE  TABLE  Track(	"id" INTEGER PRIMARY KEY  NOT NULL , 	"category" TEXT, 	"description" TEXT, 	"copyCounter" INTEGER, 	"domain" TEXT, 	"editable" INTEGER, 	"kind" TEXT, 	"name" TEXT, 	"published" INTEGER, 	"type" TEXT, 	"updated" INTEGER, 	"version" INTEGER,	"clean" INTEGER);
CREATE TABLE  TrackSiine(	track INTEGER NOT NULL,	siine INTEGER NOT NULL,	"position" INTEGER,	CONSTRAINT fk_tracksiine_track FOREIGN KEY(track) REFERENCES Track(id),	CONSTRAINT fk_tracksiine_siine FOREIGN KEY(siine) REFERENCES Siine(id));

DROP TABLE IF EXISTS ModuleTrack;
DROP TABLE IF EXISTS Module;
CREATE  TABLE  Module(	"id" INTEGER PRIMARY KEY  NOT NULL , 	"name" TEXT, 	pod INTEGER,	syntaxTrack0 INTEGER,	syntaxTrack1 INTEGER,	"position" INTEGER, 	"category" TEXT, 	"domain" TEXT, 	"kind" TEXT, 	"type" TEXT, 	"clean" INTEGER,	"published" INTEGER, 	"updated" INTEGER, 	"version" INTEGER,	CONSTRAINT fk_module_pod FOREIGN KEY(pod) REFERENCES Pod(id),	CONSTRAINT fk_module_track0 FOREIGN KEY(syntaxTrack0) REFERENCES Track(id)	CONSTRAINT fk_module_track1 FOREIGN KEY(syntaxTrack1) REFERENCES Track(id));
CREATE  TABLE  ModuleTrack(	module INTEGER NOT NULL,	track INTEGER NOT NULL,	"position" INTEGER,	CONSTRAINT fk_moduletrack_module FOREIGN KEY(module) REFERENCES Module(id),	CONSTRAINT fk_moduletrack_track FOREIGN KEY(track) REFERENCES Track(id));

DROP TABLE IF EXISTS Pod;
CREATE  TABLE  Pod(	"id" INTEGER PRIMARY KEY  NOT NULL , 	"name" TEXT, 	"image" INTEGER, 	"published" INTEGER, 	"updated" INTEGER, 	"version" INTEGER,	"clean" INTEGER,	CONSTRAINT fk_pod_image FOREIGN KEY(image) REFERENCES Image(id)	CONSTRAINT un_pod_name UNIQUE(name));

--Add indexes for autocomplete search
DROP INDEX IF EXISTS Siine_werds;
CREATE INDEX Siine_werds ON Siine(tag);

DROP INDEX IF EXISTS SiineText_autocomplete;
CREATE INDEX SiineText_autocomplete ON SiineText(siine,text);
